module Calendar.Egyptian where

import Calendar.Global

data Egyptian = EgyptianData {egyptian'year::Fixed, egyptian'month::Fixed,
                                             egyptian'day::Fixed} deriving (Eq, Show)

egyptianEpoch = fixedFromJD 1448638

fixedFromEgyptian e = egyptianEpoch + toInteger (
                                        (365 * ((egyptian'year e) - 1) +
                                           (30 * ((egyptian'month e) - 1)) +
                                               (egyptian'day e) - 1))

egyptianFromFixed :: Fixed -> Egyptian
egyptianFromFixed fixed = let
    days = (fixed - egyptianEpoch) in (let
    year = floor ((fromInteger days) / 365) + 1 in (let
    month = floor (((fromInteger (days `mod` 365)) / 30)) + 1 in (let
    day = days - 365 * (year - 1) - 30 * (month - 1) +1 in
          EgyptianData year month day)))

