-- Basic types and functions

module Calendar.Global where

-- jd = julian day, *not* to be mistaken for the Julian calendar, julian 
-- days are used by astronomers.

-- RD : Rata Die also called "fixed"

-- moment : RD with a fractional part

type JD = Double
jdEpoch = -1721424.5::JD

type Fixed = Integer
type Moment = Double

momentFromJD :: JD -> Moment
momentFromJD jd = jd + jdEpoch

jdFromMoment :: Moment -> JD
jdFromMoment t = t - jdEpoch

-- TODO: modified JD, which has a different epoch

fixedFromJD :: JD -> Fixed
fixedFromJD jd = floor (momentFromJD jd)

jdFromFixed :: Fixed -> JD
jdFromFixed = jdFromMoment . fromInteger
