module Calendar.Utils where

import Calendar.Egyptian
import Calendar.Julian
import Calendar.Gregorian
import Calendar.Islamic
import Calendar.Mayan
import Calendar.FrenchRevolutionary

-- Conversions from one calendar to another. All conversions are done
-- by using a pivot, the Fixed Day calendar. We convert the source in
-- Fixed, then we convert the Fixed date in the destination.

islamic2gregorian = gregorianFromFixed . fixedFromIslamic
gregorian2islamic = islamicFromFixed . fixedFromGregorian

islamic2julian = islamicFromFixed . fixedFromJulian
julian2islamic = julianFromFixed . fixedFromIslamic

gregorian2julian = julianFromFixed . fixedFromGregorian
julian2gregorian = gregorianFromFixed . fixedFromJulian

gregorian2mayan = mayanLongCountFromFixed . fixedFromGregorian
mayan2gregorian = gregorianFromFixed . fixedFromMayanLongCount

islamic2republican = modifiedFrenchRevFromFixed . fixedFromIslamic
republican2islamic = islamicFromFixed . fixedFromModifiedFrenchRev

systemTimeEpoch = fixedFromGregorian (toGregorian 1970 1 1)

