module Main where 

import System.Time

import Calendar.Utils
import Calendar.Egyptian
import Calendar.Julian
import Calendar.Gregorian
import Calendar.Islamic
import Calendar.Mayan
import Calendar.FrenchRevolutionary

getToday = do
  (TOD seconds _) <- getClockTime
  return (floor(fromIntegral seconds/86400) + systemTimeEpoch)

main = do
  today <- getToday
  let todayIslamic = islamicFromFixed today
  let todayGregorian = gregorianFromFixed today
  let todayMayan = mayanLongCountFromFixed today
  let todayFrenchRev = modifiedFrenchRevFromFixed today
  putStrLn "Today is... "
  putStrLn ("Fixed: " ++ (show today))
  putStrLn ("Egyptian: " ++ show (egyptianFromFixed today))
  putStrLn ("Gregorian: " ++ Calendar.Gregorian.prettyShow todayGregorian ++ " (" ++ show todayGregorian ++ ")")
  putStrLn ("Julian: " ++ show (julianFromFixed today))
  putStrLn ("Islamic: " ++ Calendar.Islamic.prettyShow todayIslamic ++ " (" ++ show todayIslamic ++ ")")
  putStrLn ("Mayan (long count): " ++ Calendar.Mayan.prettyShow todayMayan)
  putStrLn ("French revolutionary: " ++ Calendar.FrenchRevolutionary.prettyShow todayFrenchRev)